﻿#------------------------------------------------------------------------------#
# Name:        Utilisation de la SDL avec Python 3 (Pygame)                    #
# Purpose:     Initiation à la programmation graphique                         #
#                                                                              #
#                                                                              #
# Author:      Jean-Christophe Dagnet - Lycée Louis Bascan                     #
#                                                                              #
# Created:     04/04/2019                                                      #
# Version:     2.0                                                             #
# MAJ :        04/2023                                                         #
# Copyright:   (c) JC 2019                                                     #
#------------------------------------------------------------------------------#

# Importation complète de la bibliothèque Graphique
# Permet entre autre d'importer la bibliothèque pygame et ses constantes
from graphique import *


# Déclaration, initialisation des variables et ouverture de la fenêtre Pygame
WIDTH = 680 ;   HEIGHT = 480
fenetre = pygame.display.set_mode((WIDTH, HEIGHT))

# Remplissage du fond de la fenêtre
fenetre.fill((darkkhaki))

################################################################################
#                            Affichage d'un texte                              #
################################################################################
# Paramètres d'entrées :                                                       #
#                                                                              #
#   1. Surface sur laquelle on dessine                                         #
#   2. texte à afficher                                                        #
#   3. Taille du texte (en pixels)                                             #
#   4. Abscisse du coin en haut à gauche                                       #
#   5. Ordonnée du coin en haut à gauche                                       #
#   6. Couleur du texte                                                        #
################################################################################
aff_pol(fenetre, "Voici votre premier affichage avec la SDL !", 40, 20, 20, violet)
aff_pol(fenetre, "Cliquer dans la fenêtre pour la suite...", 30, 40, 50, rouge)


# Rafraîchissement de l'écran pour assurer l'affichage
# Sans cette fonction aucun affichage est réalisé
pygame.display.flip()

# Attente d'un clic pour poursuivre l'annimation
wait_clic()

################################################################################
#                            Dessin d'un rectangle                             #
################################################################################
# Paramètres d'entrées :                                                       #
#                                                                              #
#   1. Surface sur laquelle on dessine                                         #
#   2. Couleur                                                                 #
#   3. Tuple :  - Abscisse du coin en haut à gauche                            #
#               - Ordonnée du coin en haut à gauche                            #
#               - Largeur du rectangle                                         #
#               - Hauteur du rectangle                                         #
#   4. remplissage :     0 : Remplis                                           #
#                       >0 : Epaisseur du trait en pixels                      #
#                       <0 : Rien n'est dessiné                                #
################################################################################
pygame.draw.rect(fenetre, red, (240, 140, 200, 200), 0)

# Affichage, rafraichissement et attente d'un clic pour continuer l'animation
aff_pol(fenetre, "Cliquer de nouveau dans la fenêtre pour la suite...", 30, 60, 70, bleumarine)
pygame.display.flip()
wait_clic()

################################################################################
#                            Dessin d'un cercle                                #
################################################################################
# Paramètres d'entrées :                                                       #
#                                                                              #
#   1. Surface sur laquelle on dessine                                         #
#   2. Couleur                                                                 #
#   3. Tuple d'entiers :  - Abscisse du centre du cercle                       #
#                         - Ordonnée du centre du cercle                       #
#   4. rayon du cercle                                                         #
#   5. remplissage :     0 : Remplis                                           #
#                       >0 : Epaisseur du trait en pixels                      #
#                       <0 : Rien n'est dessiné                                #
################################################################################
# ATTENTION : la fonction draw_circle de la bibliothèque pygame prend          #
#             des tuples d'entiers en argument et non pas des flotants !       #
################################################################################
pygame.draw.circle(fenetre, bleu, (300, 200), 20, 0)
pygame.draw.circle(fenetre, bleu, (380, 200), 20, 0)


# Affichage, rafraichissement et attente d'un clic pour continuer l'animation
aff_pol(fenetre, "Cliquer encore dans la fenêtre pour la suite...", 30, 80, 90, vert)
pygame.display.flip()
wait_clic()

################################################################################
#                            Dessin d'une ligne                                #
################################################################################
# Paramètres d'entrées :                                                       #
#                                                                              #
#   1. Surface sur laquelle on dessine                                         #
#   2. Couleur                                                                 #
#   3. Tuple :  - Abscisse du premier point                                    #
#               - Ordonnée du premier point                                    #
#   4. Tuple :  - Abscisse du deuxième point                                   #
#               - Ordonnée du deuxième point                                   #
#   5. remplissage :     0 : Remplis                                           #
#                       >0 : Epaisseur du trait en pixels                      #
#                       <0 : Rien n'est dessiné                                #
################################################################################
pygame.draw.line(fenetre, turquoise, (300, 270), (380, 290), 3)


# Affichage de fin de programme
aff_pol(fenetre, "Ce programme est terminé, vous pouvez passer à la suite du TP...", 30, 30, HEIGHT - 80, gris)


# Rafraîchissement de l'écran pour assurer l'affichage
# Sans cette fonction aucun affichage est réalisé
pygame.display.flip()


# Fonction bloquante incluse dans la bibliothèque Graphique.py
# permettant de fermer la fenêtre et de stopper le programme
aff_pol(fenetre, "Appuyer sur Echap pour quiter", 25, 20, HEIGHT - 20, gris, True, True)
pygame.display.flip()
wait_escape()

################################################################################
#                               FIN DU PROGRAMME                               #
################################################################################
